"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ImmutableXController = void 0;
var bytes_1 = require("@ethersproject/bytes");
var keccak256_1 = require("@ethersproject/keccak256");
var signing_key_1 = require("@ethersproject/signing-key");
var solidity_1 = require("@ethersproject/solidity");
var strings_1 = require("@ethersproject/strings");
var imx_link_crypto_1 = require("@imtbl/imx-link-crypto");
var imx_link_types_1 = require("@imtbl/imx-link-types");
var fp_1 = require("../../libs/fp");
var utils_1 = require("../../libs/utils");
var auto_bind_1 = __importDefault(require("auto-bind"));
var contracts_1 = require("../../contracts");
var encUtils = __importStar(require("enc-utils"));
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var TE = __importStar(require("fp-ts/TaskEither"));
var soltypes_1 = require("soltypes");
/**
 * Immutable X Controller
 */
var ImmutableXController = /** @class */ (function () {
    function ImmutableXController(signer, accountMappingKey) {
        var _this = this;
        if (accountMappingKey === void 0) { accountMappingKey = imx_link_crypto_1.DEFAULT_ACCOUNT_MAPPING_KEY; }
        this.signer = signer;
        this.accountMappingKey = accountMappingKey;
        if (!signer.provider) {
            throw new Error('Signer is required to have a provider!');
        }
        var storage = {};
        this.store = {
            set: function (key, data) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    storage[key] = data;
                    return [2 /*return*/];
                });
            }); },
            get: function (key) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, storage[key]];
                });
            }); },
            remove: function (key) { return __awaiter(_this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    delete storage[key];
                    return [2 /*return*/];
                });
            }); },
        };
        auto_bind_1.default(this);
    }
    // -- Public -- //
    ImmutableXController.prototype.getAddress = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = function_1.pipe;
                        return [4 /*yield*/, this.signer.getAddress()];
                    case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent(), function (address) { return address.toLowerCase(); },
                            imx_link_types_1.EthAddress.decode,
                            fp_1.valueOrThrow])];
                }
            });
        });
    };
    Object.defineProperty(ImmutableXController.prototype, "starkPublicKey", {
        get: function () {
            if (!this.activeKeyPair)
                return undefined;
            return encUtils.sanitizeHex(imx_link_crypto_1.getXCoordinate(imx_link_crypto_1.getStarkPublicKey(this.activeKeyPair)));
        },
        enumerable: false,
        configurable: true
    });
    ImmutableXController.prototype.getStarkPublicKey = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var keyPair;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getKeyPairFromPath(path)];
                    case 1:
                        keyPair = _a.sent();
                        return [2 /*return*/, encUtils.sanitizeHex(imx_link_crypto_1.getXCoordinate(imx_link_crypto_1.getStarkPublicKey(keyPair)))];
                }
            });
        });
    };
    ImmutableXController.prototype.getExchangeContract = function (contractAddress) {
        if (!this.signer.provider) {
            throw new Error('Please set a provider first - call setProvider()');
        }
        return contracts_1.Stark__factory.connect(contractAddress, this.signer);
    };
    // Signing - via eth key
    ImmutableXController.prototype.sign = function (payload) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var hash, sig, _b;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        hash = keccak256_1.keccak256(strings_1.toUtf8Bytes(JSON.stringify(payload)));
                        _b = imx_link_crypto_1.deserializeSignature;
                        return [4 /*yield*/, this.signer.signMessage(hash)];
                    case 1:
                        sig = _b.apply(void 0, [_c.sent()]);
                        return [2 /*return*/, encUtils.addHexPrefix(encUtils.padLeft(sig.r.toString(16), 64) +
                                encUtils.padLeft(sig.s.toString(16), 64) +
                                encUtils.padLeft(((_a = sig.recoveryParam) === null || _a === void 0 ? void 0 : _a.toString(16)) || '', 2))];
                }
            });
        });
    };
    // Signing - via stark key
    ImmutableXController.prototype.signStark = function (payload) {
        return __awaiter(this, void 0, void 0, function () {
            var key, signingKey, hash, signature;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getActiveKeyPair()];
                    case 1:
                        key = (_a.sent()).getPrivate('hex');
                        signingKey = new signing_key_1.SigningKey(imx_link_crypto_1.isHexPrefixed(key) ? key : '0x' + key);
                        hash = keccak256_1.keccak256(strings_1.toUtf8Bytes(JSON.stringify(payload)));
                        signature = bytes_1.joinSignature(signingKey.signDigest(hash));
                        return [2 /*return*/, signature];
                }
            });
        });
    };
    // Signing - via eth key for registration
    ImmutableXController.prototype.signRegistration = function () {
        return __awaiter(this, void 0, void 0, function () {
            var hash, _a, _b, _c, signature;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = solidity_1.keccak256;
                        _b = [['string', 'address', 'uint256']];
                        _c = ['UserRegistration:'];
                        return [4 /*yield*/, this.getAddress()];
                    case 1:
                        _c = _c.concat([_d.sent()]);
                        return [4 /*yield*/, this.getStarkPublicKey()];
                    case 2:
                        hash = _a.apply(void 0, _b.concat([_c.concat([_d.sent()])]));
                        return [4 /*yield*/, this.signer.signMessage(hash)];
                    case 3:
                        signature = _d.sent();
                        return [2 /*return*/, signature];
                }
            });
        });
    };
    /**
     * StarkWare JSON-RPC Spec
     */
    // Stark Off-Chain
    ImmutableXController.prototype.account = function (layer, application, index) {
        return __awaiter(this, void 0, void 0, function () {
            var path, _a, _b, starkPublicKey;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        _a = imx_link_crypto_1.getAccountPath;
                        _b = [layer, application];
                        return [4 /*yield*/, this.getAddress()];
                    case 1:
                        path = _a.apply(void 0, _b.concat([_c.sent(), index]));
                        return [4 /*yield*/, this.getStarkPublicKey(path)];
                    case 2:
                        starkPublicKey = _c.sent();
                        return [2 /*return*/, starkPublicKey];
                }
            });
        });
    };
    ImmutableXController.prototype.signUserRegistration = function (_a) {
        var _this = this;
        var etherKey = _a.etherKey, starkPublicKey = _a.starkPublicKey, nonce = _a.nonce;
        return function_1.pipe(fp_1.taskEitherWithError(function () { return __awaiter(_this, void 0, void 0, function () { return __generator(this, function (_a) {
            return [2 /*return*/, this.assertStarkPublicKey(starkPublicKey)];
        }); }); }), TE.chain(function () { return fp_1.taskEitherWithError(_this.getActiveKeyPair); }), TE.chain(function (keyPair) {
            var msg = imx_link_crypto_1.getRegisterUserMsg(etherKey, starkPublicKey, nonce);
            var signature = imx_link_crypto_1.sign(keyPair, msg);
            var starkSignature = imx_link_crypto_1.serializeSignature(signature);
            return TE.of(starkSignature);
        }));
    };
    ImmutableXController.prototype.signDeposit = function (starkPublicKey, vaultId, assetId, quantity, nonce) {
        return __awaiter(this, void 0, void 0, function () {
            var msg, keyPair, signature, starkSignature;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        msg = imx_link_crypto_1.getDepositMsg(quantity.toString(), nonce, vaultId, assetId, starkPublicKey);
                        return [4 /*yield*/, this.getActiveKeyPair()];
                    case 2:
                        keyPair = _a.sent();
                        signature = imx_link_crypto_1.sign(keyPair, msg);
                        starkSignature = imx_link_crypto_1.serializeSignature(signature);
                        return [2 /*return*/, starkSignature];
                }
            });
        });
    };
    ImmutableXController.prototype.signWithdraw = function (starkPublicKey, vaultId, token, assetId, quantity, nonce) {
        var _this = this;
        return fp_1.taskEitherWithError(function () { return __awaiter(_this, void 0, void 0, function () {
            var quantizedAmount, msg, keyPair, signature, starkSignature;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        quantizedAmount = utils_1.tokenQuantizedAmount(token, quantity);
                        msg = imx_link_crypto_1.getWithdrawMsg(quantizedAmount.toString(), nonce, vaultId, assetId, starkPublicKey);
                        return [4 /*yield*/, this.getActiveKeyPair()];
                    case 2:
                        keyPair = _a.sent();
                        signature = imx_link_crypto_1.sign(keyPair, msg);
                        starkSignature = imx_link_crypto_1.serializeSignature(signature);
                        return [2 /*return*/, starkSignature];
                }
            });
        }); });
    };
    ImmutableXController.prototype.transfer = function (from, to, token, assetId, quantity, nonce, expirationTimestamp) {
        var _this = this;
        return fp_1.taskEitherWithError(function () { return __awaiter(_this, void 0, void 0, function () {
            var quantizedAmount, msg, keyPair, signature, starkSignature;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(from.starkPublicKey)];
                    case 1:
                        _a.sent();
                        quantizedAmount = utils_1.tokenQuantizedAmount(token, quantity);
                        msg = imx_link_crypto_1.getTransferMsg(quantizedAmount.toString(), nonce, String(from.vaultId), assetId, String(to.vaultId), to.starkPublicKey, expirationTimestamp);
                        return [4 /*yield*/, this.getActiveKeyPair()];
                    case 2:
                        keyPair = _a.sent();
                        signature = imx_link_crypto_1.sign(keyPair, msg);
                        starkSignature = imx_link_crypto_1.serializeSignature(signature);
                        return [2 /*return*/, starkSignature];
                }
            });
        }); });
    };
    ImmutableXController.prototype.createOrder = function (starkPublicKey, sell, buy, sell_id, buy_id, nonce, expirationTimestamp) {
        var _this = this;
        return fp_1.taskEitherWithError(function () { return __awaiter(_this, void 0, void 0, function () {
            var msg, keyPair, signature, starkSignature;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        msg = imx_link_crypto_1.getLimitOrderMsg(String(sell.vaultId), String(buy.vaultId), utils_1.tokenQuantizedAmount(sell.token, sell.quantity).toString(), utils_1.tokenQuantizedAmount(buy.token, buy.quantity).toString(), sell_id, buy_id, String(nonce), String(expirationTimestamp));
                        return [4 /*yield*/, this.getActiveKeyPair()];
                    case 2:
                        keyPair = _a.sent();
                        signature = imx_link_crypto_1.sign(keyPair, msg);
                        starkSignature = imx_link_crypto_1.serializeSignature(signature);
                        return [2 /*return*/, starkSignature];
                }
            });
        }); });
    };
    ImmutableXController.prototype.getCancelOrderMsg = function (orderId) {
        return function_1.pipe(E.tryCatch(function () { return imx_link_crypto_1.getCancelOrderMsg(orderId); }, function (e) { return e; }), TE.fromEither);
    };
    ImmutableXController.prototype.signF = function (_a) {
        var keyPair = _a.keyPair, msg = _a.msg;
        return function_1.pipe(E.tryCatch(function () { return imx_link_crypto_1.sign(keyPair, msg); }, function (e) { return e; }), TE.fromEither);
    };
    ImmutableXController.prototype.serializeSignature = function (signature) {
        return function_1.pipe(E.tryCatch(function () { return imx_link_crypto_1.serializeSignature(signature); }, function (e) { return e; }), TE.fromEither);
    };
    ImmutableXController.prototype.cancelOrder = function (orderId) {
        var _this = this;
        return function_1.pipe(this.getCancelOrderMsg(orderId), TE.map(function (msg) { return ({ msg: msg }); }), TE.bind('keyPair', function_1.constant(TE.tryCatch(function () { return _this.getActiveKeyPair(); }, function (e) { return e; }))), TE.chain(this.signF), TE.chain(this.serializeSignature));
    };
    // Stark On-Chain
    ImmutableXController.prototype.register = function (_a) {
        var _this = this;
        var contractAddress = _a.contractAddress, etherKey = _a.etherKey, starkPublicKey = _a.starkPublicKey, operatorSignature = _a.operatorSignature;
        return fp_1.taskEitherWithError(function () {
            var exchangeContract = _this.getExchangeContract(contractAddress);
            return exchangeContract.populateTransaction.registerUser(etherKey, starkPublicKey, operatorSignature);
        });
    };
    ImmutableXController.prototype.depositF = function (_a) {
        var _b;
        var contractAddress = _a.contractAddress, starkPublicKey = _a.starkPublicKey, quantity = _a.quantity, assetId = _a.assetId, token = _a.token, vaultId = _a.vaultId;
        var exchangeContract = this.getExchangeContract(contractAddress);
        var assetType = token.type === imx_link_types_1.ERC721TokenType.ERC721
            ? imx_link_crypto_1.getAssetType(token).toUint().val
            : new soltypes_1.Bytes32(assetId).toUint().val;
        return fp_1.switchCase(token.type, (_b = {},
            _b[imx_link_types_1.ETHTokenType.ETH] = function () {
                return function_1.pipe(fp_1.taskEitherWithError(function () {
                    return exchangeContract.populateTransaction['deposit(uint256,uint256,uint256)'](starkPublicKey, assetType, vaultId);
                }), TE.map(function (unsignedTrx) { return (__assign(__assign({}, unsignedTrx), { value: quantity })); }));
            },
            _b[imx_link_types_1.ERC20TokenType.ERC20] = function () {
                return fp_1.taskEitherWithError(function () {
                    return exchangeContract.populateTransaction['deposit(uint256,uint256,uint256,uint256)'](starkPublicKey, assetType, vaultId, quantity);
                });
            },
            _b[imx_link_types_1.ERC721TokenType.ERC721] = function () {
                return fp_1.taskEitherWithError(function () {
                    return exchangeContract.populateTransaction.depositNft(starkPublicKey, assetType, vaultId, token.data.tokenId);
                });
            },
            _b), function () { return TE.left(new Error('Invalid token type')); });
    };
    ImmutableXController.prototype.deposit = function (params) {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, fp_1.decodeForFunction(params, imx_link_types_1.StarkMethodParams.StarkDepositParamsCodec.decode, this.depositF)];
            });
        });
    };
    ImmutableXController.prototype.depositCancel = function (contractAddress, starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetType, unsignedTrx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        exchangeContract = this.getExchangeContract(contractAddress);
                        assetType = imx_link_crypto_1.getAssetType(token).toUint().val;
                        return [4 /*yield*/, exchangeContract.populateTransaction.depositCancel(starkPublicKey, assetType, vaultId)];
                    case 2:
                        unsignedTrx = _a.sent();
                        return [2 /*return*/, unsignedTrx];
                }
            });
        });
    };
    ImmutableXController.prototype.depositReclaim = function (contractAddress, starkPublicKey, token, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetType, unsignedTrx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        exchangeContract = this.getExchangeContract(contractAddress);
                        assetType = imx_link_crypto_1.getAssetType(token).toUint().val;
                        return [4 /*yield*/, exchangeContract.populateTransaction.depositReclaim(starkPublicKey, assetType, vaultId)];
                    case 2:
                        unsignedTrx = _a.sent();
                        return [2 /*return*/, unsignedTrx];
                }
            });
        });
    };
    ImmutableXController.prototype.withdrawal = function (contractAddress, starkPublicKey, token) {
        var _this = this;
        return fp_1.taskEitherWithError(function () { return __awaiter(_this, void 0, void 0, function () {
            var exchangeContract, assetType, mintToken;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        exchangeContract = this.getExchangeContract(contractAddress);
                        assetType = imx_link_crypto_1.getAssetType(token).toUint().val;
                        if (!(token.type.toUpperCase() === imx_link_types_1.ETHTokenType.ETH || token.type.toUpperCase() === imx_link_types_1.ERC20TokenType.ERC20)) return [3 /*break*/, 3];
                        return [4 /*yield*/, exchangeContract.populateTransaction.withdraw(starkPublicKey, assetType)];
                    case 2: return [2 /*return*/, _a.sent()];
                    case 3:
                        if (!(token.type.toUpperCase() === imx_link_types_1.ERC721TokenType.ERC721)) return [3 /*break*/, 5];
                        return [4 /*yield*/, exchangeContract.populateTransaction.withdrawNft(starkPublicKey, assetType, token.data.tokenId)];
                    case 4: return [2 /*return*/, _a.sent()];
                    case 5:
                        if (!(token.type.toUpperCase() === imx_link_types_1.MintableERC20TokenType.MINTABLE_ERC20 ||
                            token.type.toUpperCase() === imx_link_types_1.MintableERC721TokenType.MINTABLE_ERC721)) return [3 /*break*/, 7];
                        mintToken = token;
                        return [4 /*yield*/, exchangeContract.populateTransaction.withdrawAndMint(starkPublicKey, assetType, imx_link_crypto_1.getMintingBlob(mintToken.data.id, mintToken.data.blueprint))];
                    case 6: // MintableERC20Token
                    return [2 /*return*/, _a.sent()];
                    case 7: throw new Error('Invalid token type');
                }
            });
        }); });
    };
    ImmutableXController.prototype.fullWithdrawal = function (contractAddress, starkPublicKey, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, unsignedTrx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        exchangeContract = this.getExchangeContract(contractAddress);
                        return [4 /*yield*/, exchangeContract.populateTransaction.fullWithdrawalRequest(starkPublicKey, vaultId)];
                    case 2:
                        unsignedTrx = _a.sent();
                        return [2 /*return*/, unsignedTrx];
                }
            });
        });
    };
    ImmutableXController.prototype.freeze = function (contractAddress, starkPublicKey, vaultId) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, unsignedTrx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        exchangeContract = this.getExchangeContract(contractAddress);
                        return [4 /*yield*/, exchangeContract.populateTransaction.freezeRequest(starkPublicKey, vaultId)];
                    case 2:
                        unsignedTrx = _a.sent();
                        return [2 /*return*/, unsignedTrx];
                }
            });
        });
    };
    // public async verifyEscape(contractAddress: string, starkPublicKey: string, proof: string[]): Promise<Transaction> {
    //     await this.assertStarkPublicKey(starkPublicKey);
    //     const exchangeContract = this.getExchangeContract(contractAddress);
    //     const unsignedTrx: Transaction = await exchangeContract.populateTransaction.verifyEscape(proof);
    //     return unsignedTrx;
    // }
    ImmutableXController.prototype.escape = function (contractAddress, starkPublicKey, vaultId, token, quantity) {
        return __awaiter(this, void 0, void 0, function () {
            var exchangeContract, assetType, quantizedAmount, unsignedTrx;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.assertStarkPublicKey(starkPublicKey)];
                    case 1:
                        _a.sent();
                        exchangeContract = this.getExchangeContract(contractAddress);
                        assetType = imx_link_crypto_1.getAssetType(token).toUint().val;
                        quantizedAmount = utils_1.tokenQuantizedAmount(token, quantity);
                        return [4 /*yield*/, exchangeContract.populateTransaction.escape(starkPublicKey, vaultId, assetType, quantizedAmount.toString())];
                    case 2:
                        unsignedTrx = _a.sent();
                        return [2 /*return*/, unsignedTrx];
                }
            });
        });
    };
    // Immutable NFT (ERC-721) Contract
    ImmutableXController.prototype.mintNFT = function (tokenAddress) {
        var nftContract = contracts_1.ImmutableX__factory.connect(tokenAddress, this.signer);
        return fp_1.taskEitherWithError(function () { return nftContract.populateTransaction.mint(); });
    };
    ImmutableXController.prototype.approveNFT = function (_a) {
        var tokenAddress = _a.tokenAddress, contractAddress = _a.contractAddress, tokenId = _a.tokenId;
        var nftContract = contracts_1.ImmutableX__factory.connect(tokenAddress, this.signer);
        return fp_1.taskEitherWithError(function () { return nftContract.populateTransaction.approve(contractAddress, tokenId); });
    };
    // -- Private -- //
    ImmutableXController.prototype.assertStarkPublicKey = function (starkPublicKey) {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = starkPublicKey;
                        return [4 /*yield*/, this.getStarkPublicKey()];
                    case 1:
                        if (_a !== (_b.sent())) {
                            throw new Error('Provided Stark key does not match with the current active key');
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXController.prototype.getActiveKeyPair = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getAccountMapping()];
                    case 1:
                        _a.sent();
                        if (this.activeKeyPair) {
                            return [2 /*return*/, this.activeKeyPair];
                        }
                        else {
                            throw new Error('No active Stark key pair - Please provide a path');
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXController.prototype.setActiveKeyPair = function (path, activeKeyPair) {
        return __awaiter(this, void 0, void 0, function () {
            var accountMapping;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getAccountMapping()];
                    case 1:
                        accountMapping = _a.sent();
                        accountMapping[path] = activeKeyPair.getPrivate('hex');
                        this.accountMapping = accountMapping;
                        this.activeKeyPair = activeKeyPair;
                        return [4 /*yield*/, this.store.set(this.accountMappingKey, accountMapping)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    ImmutableXController.prototype.getKeyPairFromPath = function (path) {
        return __awaiter(this, void 0, void 0, function () {
            var accountMapping, match, signature, activeKeyPair;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getAccountMapping()];
                    case 1:
                        accountMapping = _a.sent();
                        // IF EXIST
                        if (!path) {
                            return [2 /*return*/, this.getActiveKeyPair()];
                        }
                        match = accountMapping[path];
                        if (match) {
                            return [2 /*return*/, imx_link_crypto_1.getKeyPairFromPrivateKey(match)];
                        }
                        return [4 /*yield*/, this.signer.signMessage(imx_link_crypto_1.DEFAULT_SIGNATURE_MESSAGE)];
                    case 2:
                        signature = _a.sent();
                        activeKeyPair = imx_link_crypto_1.getKeyPairFromPath(bytes_1.splitSignature(signature).s, path);
                        return [4 /*yield*/, this.setActiveKeyPair(path, activeKeyPair)];
                    case 3:
                        _a.sent();
                        return [2 /*return*/, activeKeyPair];
                }
            });
        });
    };
    ImmutableXController.prototype.getAccountMapping = function () {
        return __awaiter(this, void 0, void 0, function () {
            var accountMapping, paths;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (typeof this.accountMapping !== 'undefined') {
                            return [2 /*return*/, this.accountMapping];
                        }
                        return [4 /*yield*/, this.store.get(this.accountMappingKey)];
                    case 1:
                        accountMapping = (_a.sent()) || {};
                        this.accountMapping = accountMapping;
                        paths = Object.keys(accountMapping);
                        if (!this.activeKeyPair && paths.length) {
                            this.activeKeyPair = imx_link_crypto_1.getKeyPairFromPrivateKey(accountMapping[paths[0]]);
                        }
                        return [2 /*return*/, accountMapping];
                }
            });
        });
    };
    return ImmutableXController;
}());
exports.ImmutableXController = ImmutableXController;
exports.default = ImmutableXController;
//# sourceMappingURL=index.js.map