"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertEither = exports.assertNever = exports.switchCase = exports.taskEitherWithError = exports.logE = exports.logTE = exports.logPipe = exports.decodeForFunction = exports.errorsToArray = exports.errorsToError = exports.valueOrThrow = void 0;
var A = __importStar(require("fp-ts/Array"));
var E = __importStar(require("fp-ts/Either"));
var function_1 = require("fp-ts/function");
var TE = __importStar(require("fp-ts/TaskEither"));
var Array_1 = require("fp-ts-std/Array");
var io_ts_reporters_1 = __importDefault(require("io-ts-reporters"));
// Convert functional to procedural code >:)
function valueOrThrow(res) {
    if (E.isRight(res)) {
        return res.right;
    }
    throw res.left;
}
exports.valueOrThrow = valueOrThrow;
var errorsToError = function (errors) {
    return function_1.pipe(errors, errorsToArray, A.map(function (e) { return e.message; }), Array_1.join('. '), function (message) { return new Error(message); });
};
exports.errorsToError = errorsToError;
function errorsToArray(errors) {
    var result = io_ts_reporters_1.default.report(E.left(errors));
    if (result.length === 0) {
        return [];
    }
    else {
        return result.map(function (r) { return new Error(r); });
    }
}
exports.errorsToArray = errorsToArray;
function decodeForFunction(params, decode, fn) {
    return __awaiter(this, void 0, void 0, function () {
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _a = valueOrThrow;
                    return [4 /*yield*/, function_1.pipe(decode(params), E.mapLeft(exports.errorsToError), TE.fromEither, TE.chain(fn))()];
                case 1: return [2 /*return*/, _a.apply(void 0, [_b.sent()])];
            }
        });
    });
}
exports.decodeForFunction = decodeForFunction;
var logPipe = function (x) {
    console.log(x);
    return x;
};
exports.logPipe = logPipe;
var logTE = function (te) {
    return TE.bimap(function (e) {
        console.error('logTE Error');
        console.dir(e, { depth: null });
        return e;
    }, function (x) {
        console.log('logTE Info');
        console.dir(x, { depth: null });
        return x;
    })(te);
};
exports.logTE = logTE;
var logE = function (te) {
    return E.bimap(function (e) {
        console.error('logE Error');
        console.error(e);
        return e;
    }, function (x) {
        console.log('logE Info');
        console.log(x);
        return x;
    })(te);
};
exports.logE = logE;
function taskEitherWithError(f) {
    return TE.tryCatch(f, function (error) { return error; });
}
exports.taskEitherWithError = taskEitherWithError;
var switchCase = function (value, cases, def) {
    return value in cases ? cases[value]() : def();
};
exports.switchCase = switchCase;
function assertNever(x) {
    throw new Error('Unexpected object: ' + x);
}
exports.assertNever = assertNever;
var assertEither = function (condition, errorMessage) {
    return condition ? E.left(new Error(errorMessage)) : E.right(null);
};
exports.assertEither = assertEither;
//# sourceMappingURL=fp.js.map